"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTestClient = void 0;
const fastify_1 = __importDefault(require("fastify"));
const graphql_1 = require("graphql");
function createTestClient({ apolloServer, requestOptions = {}, }) {
    const app = fastify_1.default();
    app.register(apolloServer.createHandler());
    let mockRequestOptions = requestOptions;
    const setOptions = ({ requestOptions, }) => {
        if (requestOptions) {
            mockRequestOptions = requestOptions;
        }
    };
    const test = (_a) => {
        var { query, mutation } = _a, args = __rest(_a, ["query", "mutation"]);
        const operation = query || mutation;
        if (!operation || (query && mutation)) {
            throw new Error('Either `query` or `mutation` must be passed, but not both.');
        }
        const opts = Object.assign({ url: apolloServer.graphqlPath, method: 'POST', payload: Object.assign({ query: typeof operation === 'string' ? operation : graphql_1.print(operation) }, args) }, mockRequestOptions);
        return app.inject(opts);
    };
    return {
        query: test,
        mutate: test,
        setOptions
    };
}
exports.createTestClient = createTestClient;
